/****************************************************************************
**
** Copyright AbouZakaria.
** All rights reserved.
** Contact: AbouZakaria (yahia67@live.com)
**
** $xbook_BEGIN_LICENSE:GPL$
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3.0 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU General Public License version 3.0 requirements will be
** met: http://www.gnu.org/copyleft/gpl.html.
**
** If you have questions regarding the use of this file, please contact
** AbouZakaria (yahia67@live.com)
** $xbook_END_LICENSE$
**
****************************************************************************/

#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include "xbook.h"
#include <QMainWindow>
#include <QTreeWidget>
#include <QDomDocument>
#include <QLabel>
#include <QTextDocument>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();
    xbook *Xbook;

protected:
    void changeEvent(QEvent *e);
signals:
    void bookAvailable(bool );

private:

    Ui::MainWindow *ui;
    bool load(const QString &f);
    QLabel *labelStatu;
    QAction *actionCopy;
    QAction *actionSelectAll;
private slots:
    ///////actions events///////////////
    void on_textEdit_customContextMenuRequested();
    void on_textEdit_textChanged();
    void on_actionArchive_triggered();
    void on_actionBookInfo_triggered();
    void on_actionClose_triggered();
    void on_actionAbout_triggered();
    void on_actionFullScreen_toggled(bool full);
    void on_pushButtonFindNext_clicked();
    void on_pushButtonFind_clicked();
    void on_toolCloseFind_clicked();
    void on_actionFind_triggered();
    void on_actionTechkile_toggled(bool r);
    void on_treeWidget_itemClicked(QTreeWidgetItem* item, int );
    void on_treeWidget_itemActivated(QTreeWidgetItem* item, int );
    void on_actionFont_triggered();
    void on_actionRecent_triggered();   
    void on_actionLast_triggered();
    void on_actionFirst_triggered();
    void on_actionPrev_triggered();
    void on_actionNext_triggered(); 
    void on_actionOpen_triggered();

   void setupUi();
    void loadLayout();
    void Savelayou();

};

#endif // MAINWINDOW_H
