/****************************************************************************
**
** Copyright AbouZakaria.
** All rights reserved.
** Contact: AbouZakaria (yahia67@live.com)
**
** $xbook_BEGIN_LICENSE:GPL$
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3.0 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU General Public License version 3.0 requirements will be
** met: http://www.gnu.org/copyleft/gpl.html.
**
** If you have questions regarding the use of this file, please contact
** AbouZakaria (yahia67@live.com)
** $xbook_END_LICENSE$
**
****************************************************************************/
#include "xbook.h"

#include <QFileDialog>
#include <QTextCodec>
#include <QXmlStreamReader>
#include <QMessageBox>
#include <QDomDocument>
#include <QTextCharFormat>
#include <QProcess>
#include <QTextStream>
#include <QSettings>
 #include <QApplication>
xbook::xbook()
{

}
bool xbook::load(const QString &f)
{
    QString finfo=f;
    QFile file(f);
    file.setFileName(f);
    QFileInfo fi(f);
    QString ext = fi.completeSuffix();
    QApplication::setOverrideCursor(QCursor(Qt::WaitCursor));
    if (ext=="bok"){
        removeTempDirs(QDir::homePath()+"/.kirtasse/xbook/");
        loadMdbBok(f);
        if( creatFiles(f)==true)  {
            file.setFileName(QDir::homePath()+"/.kirtasse/xbook/bookinfo.info");
            finfo=QDir::homePath()+"/.kirtasse/xbook/bookinfo.info";
            QDir dir;
            QString h=dir.homePath()+"/.kirtasse/xbook";
            QFile filetemp;
            if (filetemp.exists(h+"/tempbk.csv")){
                filetemp.remove(h+"/tempbk.csv");
            }
            if (filetemp.exists(h+"/temptitle.csv")){
                filetemp.remove(h+"/temptitle.csv");
            }
            if (filetemp.exists(h+"/out")){
                filetemp.remove(h+"/out");
            }
            if (filetemp.exists(h+"/main.csv")){
                filetemp.remove(h+"/main.csv");
            }
        }
    }
    if (ext=="tar.gz"|| ext=="krts"){
        removeTempDirs(QDir::homePath()+"/.kirtasse/xbook/");
        if( uzipBook(f)==true)  {
            QString tempDir;
            QString dirName=QDir::homePath()+"/.kirtasse/xbook/";
            QDir dir(dirName);
            foreach ( tempDir, dir.entryList(QDir::AllDirs | QDir::NoDotAndDotDot |
                                             QDir::Hidden )){
                if (file.exists(dirName+tempDir+"/bookinfo.info")){
                    file.setFileName(dirName+tempDir+"/bookinfo.info");
                    finfo=dirName+tempDir+"/bookinfo.info";
                }
            }


        }
    }
    if (!file.open(QFile::ReadOnly)){
        QApplication::restoreOverrideCursor();
        return false;

    }

    QFileInfo inf(finfo);
    QString nameinfo = inf.fileName();
    fileName = inf.absoluteFilePath().replace(nameinfo,QString::null);
    QString nameBook = fileName +"book.xml";
    QString nameTitle = fileName +"title.xml";

    if( loadBookInfo(finfo)==false){
         QApplication::restoreOverrideCursor();
           return false;
       }
    treeChargeFahrass(nameTitle);
    openBook( currentPosition,nameBook);
    QApplication::restoreOverrideCursor();
    return true;
}
//////////////////******************************************
void xbook::treeChargeFahrass(QString Bname)
{

    QString titlepath= Bname;
    QFile file(titlepath);
    file.open(QIODevice::ReadOnly);
    view->clear();
    int d=1;
    QTreeWidgetItem *item[d];
    QString tit;
    QString id;
    QString lvl;

    item[1]= new QTreeWidgetItem(view);
    item[1]->setText(0,trUtf8("بسم الله الرحمن الرحيم") );
    item[1]->setData(1,1,1);
    QXmlStreamReader xml;
    xml.setDevice(&file);
    if (xml.readNextStartElement()) {
        if (xml.name() == "dataroot" ){
            Q_ASSERT(xml.isStartElement() && xml.name() == "dataroot");
            while (xml.readNextStartElement()) {
                if (xml.name() == "title"){

                    //   Q_ASSERT(xml.isStartElement() && xml.name() == "book");
                    while (xml.readNextStartElement()) {
                        if (xml.name() == "id"){
                            id=xml.readElementText();


                        }else if (xml.name() == "tit"){

                            tit= xml.readElementText();
                        }else if (xml.name() == "lvl"){

                            lvl= xml.readElementText().trimmed();
                        }else{
                            xml.skipCurrentElement();
                        }


                    }
                    bool ok;
                    d=lvl.toInt(&ok,0);

                    if (ok==true){
                        if (d<1){d=1;}
                        if (d==1){
                            item[1]= new QTreeWidgetItem(view);
                            item[1]->setText(0,tit );
                            item[1]->setText(1,id );
                            item[1]->setData(1,1,id);
                        }else{
                            if (item[d-1]){
                                item[d]= new QTreeWidgetItem( item[d-1]);
                                item[d]->setText(0,tit );
                                item[d]->setText(1,id );
                                item[d]->setData(1,1,id);
                            }

                        }
                    }else{
                        item[1]= new QTreeWidgetItem(view);
                        item[1]->setText(0,tit );
                        item[1]->setText(1,id );
                        item[1]->setData(1,1,id);
                    }
                }
            }
        }


    }
    file.close();
    //listId.clear();
    xml.clear();
}

bool xbook::loadBookInfo(QString bookinfo)
{

    QFile file(bookinfo);
    QDomDocument m_doc;
    if (!file.open(QIODevice::ReadOnly)){
        return false;
    }
    if (!m_doc.setContent(&file)){
        return false;
    }

    file.close();
    QDomElement racine = m_doc.documentElement(); //
    QDomNode noeud = racine.firstChild();
    QDomElement myper=noeud.toElement();

    infoBookTitle= myper.attribute("title");
    infoBookAutor= myper.attribute("author");
    infoBookBetaka= myper.attribute("betaka");

    m_doc.clear();

    return true;
}

bool  xbook::openBook(int position,QString bkpath)
{

    QFile file(bkpath);
    if( !file.open(QIODevice::ReadOnly))                            //فتح الملف
    {

        return false;
    }


    if (!m_docBooK.setContent(&file))                                      //اذا كانت البيانات صحيحة
    {

        return false;
    }

    QDomElement racine = m_docBooK.documentElement(); //renvoie la balise racine
    QVariant i = racine.childNodes().count();
    rowsCount=i.toInt()-1;
    file.close();

    moveToPosition(position);


    return true;
}

void xbook::moveToPosition(int position)
{


    QDomElement racine = m_docBooK.documentElement(); //renvoie la balise racine
    QDomNode noeud = racine.childNodes().item(position);

    if (removeTechkile==false){
        bookNass=   noeud.firstChildElement("nass").firstChild().toText().data();
    }else{
        bookNass=noTechkile(noeud.firstChildElement("nass").firstChild().toText().data()) ;
    }
    m_bookCurentId=  noeud.firstChildElement("id").firstChild().toText().data();
    bookPage=  noeud.firstChildElement("page").firstChild().toText().data();
    bookPart=  noeud.firstChildElement("part").firstChild().toText().data();

    currentPosition=position;

    //labelStatu->setText(m_infoBookTitle+"/"+m_infoBookAutor+" : "+trUtf8("الصفحة :")+m_bookPage +"  "+trUtf8("الجزء :")+m_bookPart);
    convert_text(bookNass);
}
/////////////////*****************************************


//////////////*************mdb import*****************

 void xbook::loadMdbBok(QString fn)
 {
     if (creatBash(fn,true)==true){
         if(creatCsvFile()==true) {
             QDir dir;
             QString h=dir.homePath()+"/.kirtasse/xbook";
             enum  { NumIndex = 40};
             QString strHeaderName[NumIndex];
             //*********************************
             QFile fileCsv(h+"/main.csv");

             if (!fileCsv.open(QFile::ReadOnly)){
                 return;
             }

             QTextStream textStream(&fileCsv);
             textStream.setCodec(QTextCodec::codecForName("Windows-1256"));

             QString line;

             line = textStream.readLine();//premier line

             int tab=  line.count("|*|");//nombre col
             if (tab>=38){
                 tab=38;
             }

             for (int i=1;i<tab+2;i++){
                 if (i==tab+1){
                     strHeaderName[i]=line.section("|*|",-1);
                 }else{
                     strHeaderName[i]=line.section("|*|",i-1,i-1);
                 }
             }

             line = textStream.readAll();//2 line

             for (int i=1;i<tab+2;i++){
                 QString strValue;
                 if (i==tab+1){
                     strValue=line.section("|*|",-1);
                 }else{
                     strValue=line.section("|*|",i-1,i-1);
                 }

                 if (strHeaderName[i]=="Bk"){infoBookTitle=strValue;}
                 if (strHeaderName[i]=="Auth"){ infoBookAutor=strValue;}
                 if (strHeaderName[i]=="Betaka"){ infoBookBetaka=strValue;}
                 if (strHeaderName[i]=="BkId"){
                     m_tableBook="b"+strValue;
                     m_tableTitle="t"+strValue;
                 }

             }

         }
     }

     saveBookInfo();
 }

 bool xbook::creatBash(QString fn,bool bok)
 {
    QDir dir;
    QString h=dir.homePath()+"/.kirtasse/xbook";
    QFile file(h+"/out");
     if (!file.open(QIODevice::WriteOnly | QIODevice::Text))
         return false;
     file.setPermissions(QFile::ExeUser | QFile::WriteUser | QFile::ReadUser);
     QTextStream out(&file);
     fn.replace(" ","\\ ");

     if (bok==true){
         out << "#!/bin/sh" << "\n"<< "export MDB_ICONV='ISO8859-1'" <<"\n"
             <<  "mdb-export -d'|*|' -Q  "+fn+ " Main >> "+h+"/main.csv";

     }else{
         out << "#!/bin/sh" << "\n"<< "export MDB_ICONV='ISO8859-1'" <<"\n"
                    <<  "mdb-export -d'|*|' -Q  "+fn+ " "+m_tableBook+" >> "+h+"/tempbk.csv"  <<"\n"
                  <<  "mdb-export -d'|*|'  -Q  "+fn+ " "+m_tableTitle+" >> "+h+"/temptitle.csv";
     }
     return true;

 }

 bool xbook::creatCsvFile()
 {
      QDir dir;
     QString h=dir.homePath()+"/.kirtasse/xbook";
     QProcess prosses;
   prosses.execute(h+"/out");


 return true;

 }

 bool xbook::creatFiles(QString fn)
 {

     QFile mdbFile(fn);

     if(!mdbFile.exists()){
         QMessageBox::information(0,trUtf8("خطأ"),trUtf8("تحقق من كتابة اسم الملف بشكل صحيح  \n ")+fn);
         return false;
     }
     QDir dir;
     QString h=dir.homePath()+"/.kirtasse/xbook";
     if (!dir.exists(h)) //التاكد من وجود مجلد المكتبة
     {
         return false;
     }
     QFile filetemp;
     if (filetemp.exists(h+"/tempbk.csv")){
         filetemp.remove(h+"/tempbk.csv");
     }
     if (filetemp.exists(h+"/temptitle.csv")){
         filetemp.remove(h+"/temptitle.csv");
     }
     if (filetemp.exists(h+"/out")){
         filetemp.remove(h+"/out");
     }
     if  (creatBash(fn,false)==true){
         qApp->processEvents();

         if (creatCsvFile()==true){
             qApp->processEvents();

             if ( creatXmlFile(h+"/book.xml","book","/tempbk.csv")==true){
                 creatXmlFile(h+"/title.xml","title","/temptitle.csv");

             }else{ QMessageBox::information(0,trUtf8("خطأ"),trUtf8("لم استطع انشاء ملف الكتاب ربما لا تملك صلاحيات الكتابة"));}
         }else{ QMessageBox::information(0,trUtf8("خطأ"),trUtf8("ربما ملف الكتب غير صحيح او فاسد"));}
     }else{ QMessageBox::information(0,trUtf8("خطأ"),trUtf8("ربما لا تملك صلاحيات الكتابة"));}


     return true;
 }

 bool xbook::creatXmlFile(QString f,QString table,QString csv)
 {
     QDir dir;
     QString h=dir.homePath()+"/.kirtasse/xbook";
     enum  { NumIndex = 10};
     QXmlStreamWriter stream;

     QString strHeaderName[NumIndex];
     //*********************************
     QFile fileCsv(h+csv);

     if (!fileCsv.open(QFile::ReadOnly)){
         return false;
     }

     QTextStream textStream(&fileCsv);
     textStream.setCodec(QTextCodec::codecForName("Windows-1256"));


     QString line;
     line = textStream.readLine();//premier line

     int tab=  line.count("|*|");//nombre col
     for (int i=1;i<tab+2;i++){
         if (i==tab+1){
             strHeaderName[i]=line.section("|*|",-1);
         }else{
             strHeaderName[i]=line.section("|*|",i-1,i-1);
         }

     }
     //*********************ecrir
     QFile file(f);
     if (!file.open(QFile::WriteOnly | QFile::Text)) {

         return false;
     }

     stream.setDevice(&file);
     stream.setAutoFormatting(true);
     stream.writeStartDocument();
     stream.writeStartElement("dataroot");

     //int r=0;
     while (!line.isNull()) {
         //         r++;
         //         if (r==1000){r=0;}
         qApp->processEvents();

         line = textStream.readLine();

         //   QMessageBox::information(this,trUtf8("خطأ"),line);
         stream.writeStartElement(table);//"book" or "title"
         //**************************************start book

         for (int i=1;i<tab+2;i++){
             QString strValue;
             if (i==tab+1){
                 strValue=line.section("|*|",-1);
             }else{
                 strValue=line.section("|*|",i-1,i-1);
             }
             if (strValue.isEmpty() || strValue==0){strValue="1";}
             if (strHeaderName[i]=="hno" || strHeaderName[i]=="na" || strHeaderName[i]=="sub"){
                 //*--
             }else if(strHeaderName[i]=="id"){
                 if (table=="book"){
                     m_listId.append(strValue);
                 }else{
                     int newid=m_listId.indexOf(strValue);
                     if (newid==-1){newid=0;}
                     QVariant dd= newid+1;
                     strValue=dd.toString();
                 }

                 stream.writeTextElement(strHeaderName[i], strValue);
             }else{

                 stream.writeTextElement(strHeaderName[i], strValue);
             }
         }
         stream.writeEndElement(); // book table
         //***************************************    end book
     }
    stream.writeEndElement(); // dataroot
     stream.writeEndDocument();

     return true;
 }

 bool xbook::saveBookInfo()
 {
     QFile file;

     QString h=QDir::homePath()+"/.kirtasse/xbook";
     QString path=h+"/bookinfo.info";

     file.setFileName(path);

     if(! file.open(QIODevice::WriteOnly)) {
         return false;
     }
         //فتح الملف للكتابة

     QString myxmltitle="<?xml version='1.0' encoding='UTF-8'?>"
                        "<dataroot>"
                        "</dataroot>";
     QDomDocument m_doc;
     m_doc.setContent(myxmltitle);
    // QString grouptext;
     QDomElement racine = m_doc.documentElement();
     QDomElement groupe=m_doc.createElement("groupe");     //انشاء عنصر جديد
     racine.appendChild(groupe);                       //الكتابة

     groupe.setAttribute("title",infoBookTitle);
     groupe.setAttribute("author",infoBookAutor);
     groupe.setAttribute("betaka",infoBookBetaka);

     QTextStream out(&file);                  //حفظ الملف
      m_doc.save(out,1);
     file.close();
     m_doc.clear();
     return true;
 }


////////////***********tar.gz*************************
bool xbook::loadTarGz(QString path)
{
 removeTempDirs(QDir::homePath()+"/.kirtasse/xbook/");
    if(uzipBook(path)==true){
        return true;
    }
     return false;
}

bool xbook::uzipBook(QString path)
{

    QDir dir;
    QString h=dir.homePath();

    if (!dir.exists(h+"/.kirtasse/xbook")) //التاكد من وجود مجلد المكتبة
    {
        dir.mkdir( h+"/.kirtasse/xbook");
    }
    QString pathToExtract=QDir::homePath()+"/.kirtasse/xbook";
// path.replace(" ","\\ ");
//QMessageBox::information(0,trUtf8("خطأ"),"tar -xvf  \""+path+"\" -C  "+pathToExtract);
     QProcess prosses;
     prosses.execute("tar -xvf  \""+path+"\" -C  "+pathToExtract);
     return true;

}

void xbook::removeTempDirs(QString dirName)
{
    removeTempFiles(dirName);
    QString subdir;

      QDir dir(dirName);
      foreach ( subdir, dir.entryList(QDir::AllDirs | QDir::NoDotAndDotDot |
                                      QDir::Hidden )){

          if ( removeTempFiles(dirName+subdir)==true){
            // QMessageBox::information(0,trUtf8("خطأ"),dirName+"/"+subdir);
              removeTempDirs(dirName+"/"+subdir);
             dir.rmdir(subdir);

          }

      }
}

bool  xbook::removeTempFiles(QString tempDir)
{

        QDir dirS(tempDir);
        QString subfile;
        QFile filetemp;
        foreach ( subfile, dirS.entryList(QDir::AllEntries)){

            filetemp.remove(tempDir+"/"+subfile);
        }

return true;


}

bool xbook::creatArchive()
{

    QDir dirF(fileName);
    if (!dirF.exists()){
        return false;
    }
    QString dirParent=fileName;
    QString dirName=dirF.dirName();
    dirParent.replace(dirName,QString::null);
    dirParent.replace("//",QString::null);

    QDir::setCurrent(dirParent);

    QString title=infoBookTitle;
    title.replace(" ","_");
    QProcess prosses;
    prosses.execute("tar -cvzf "+ QDir::homePath()+"/"+title+".krts "+ dirName);
    return true;
}
/////************text************************************
QString xbook::noTechkile(QString text) const
{
    QString str=text;
    str.replace(trUtf8("\331\213"),QString::null);
    str.replace(trUtf8("\331\214"),QString::null);
    str.replace(trUtf8("\331\215"),QString::null);
    str.replace(trUtf8("\331\216"),QString::null);
    str.replace(trUtf8("\331\217"),QString::null);
    str.replace(trUtf8("\331\220"),QString::null);
    str.replace(trUtf8("\331\221"),QString::null);
    str.replace(trUtf8("\331\222"),QString::null);
    return str;
}

void xbook::convert_text(QString txt)//تحويل بيانات النص
{

    QTextCodec::setCodecForCStrings(QTextCodec::codecForName("UTF-8"));


    txt.replace(QByteArray("\n"), QByteArray("<br>"));
    txt.replace(QByteArray("\r"), QByteArray("<br>"));
    //*******************************************
    if (txt.contains("$")){
        txt.replace("$", "");
    }


    QVariant dd=currentPosition+1;
    QTreeWidgetItem *item=new QTreeWidgetItem;
    QList<QTreeWidgetItem *> found =
           view->findItems(
                    dd.toString(),Qt::MatchExactly | Qt::MatchRecursive,1);//تنشاء قائمة بكل العناصر

    foreach (item, found){
        view->setCurrentItem(item);
        //    QMessageBox::information(this,trUtf8("llop"),item->text(0));

        QString title= " <span style='font-family:"+fontName+"; color:red;'>"+item->text(0)+"</span>";
        txt.replace( item->text(0).trimmed()+"<br>","<br>"+title+"<br>");
    //  txt.replace( item->text(0).trimmed(),"<br>"+title+"<br>");
        txt.replace( item->text(0).trimmed()+" <br>","<br>"+title+"<br>");

       // txt.replace("  "+ item->text(0),"<br>"+title+"<br>");
        txt.replace("<br>"+ item->text(0).trimmed(),"<br>"+title+"<br>");

        txt.replace( item->text(0).trimmed()+" :","<br>"+title+":<br>");
        txt.replace( item->text(0).trimmed()+":","<br>"+title+":<br>");
        txt.replace( item->text(0).trimmed()+".","<br>"+title+"<br>");
        txt.replace( item->text(0).trimmed()+" ؟","<br>"+title+" ؟<br>");
        txt.replace("[ "+ item->text(0).trimmed()+" ]","<br>"+title+"<br>");
        txt.replace("["+ item->text(0).trimmed()+"]","<br>"+title+"<br>");
        if(txt.trimmed()== item->text(0).trimmed()){
            txt=title;
        }
    }

    //********************************************
    QRegExp rxi("_____+");
    QRegExp rxd("ـــــ+");
    txt.replace(rxi," < font  size='1'><br>__________");
    txt.replace(rxd," < font   size='1'><br>__________");

    txt.replace("C رحمه الله تعالى","تعالى");
    txt.replace("{","< font color='red' >﴿</font> ");
    txt.replace("}","< font color='red' >﴾</font> ");

    txt.replace(" A ",trUtf8(" صلى الله عليه سلم "));
    txt.replace("Bه",trUtf8("رضي الله عنه"));
    txt.replace(" D ",trUtf8(" تعالى "));
    txt.replace(" E ",trUtf8(" عليه السلام "));
txt.replace("النبي e",trUtf8("النبي صلى الله عليه سلم "));
    if (txt.contains("**")){
        QRegExp rx("(\\d\\d? )[(]");
        txt.replace(rx,"<br>(");
        QRegExp rx1("(\\d\\d?)[(]");
        txt.replace(rx1,"<br>(");
        txt.replace(") (",")<br>(");
        txt.replace(")(",")<br>(");
    }
    txt.replace("<br><br>","<br>");
    txt.replace("<br> <br>","<br>");
    txt.replace("<br>  <br>","<br>");

    textEdit->setHtml( txt.trimmed() +"</font></body>");

}

/////////////search**********************************************************

bool  xbook::searchInDoc(QTextDocument *document,QString searchString)
{

    bool found = false;
    document->undo();
    QTextCursor highlightCursor(document);
    QTextCursor cursor(document);
    cursor.beginEditBlock();
    QTextCharFormat plainFormat(highlightCursor.charFormat());
    QTextCharFormat colorFormat = plainFormat;
    colorFormat.setForeground(QColor::fromRgb(255,83,0));
    while (!highlightCursor.isNull() && !highlightCursor.atEnd()) {
        highlightCursor = document->find(searchString, highlightCursor, QTextDocument::FindCaseSensitively);

        if (!highlightCursor.isNull()) {
            found = true;
            highlightCursor.movePosition(QTextCursor::Right,
                                         QTextCursor::KeepAnchor);

            highlightCursor.mergeCharFormat(colorFormat);

        }
    }
    cursor.endEditBlock();

    if (found == false) {
        return false;
    }

    return true;
}
void xbook::findNext(QTextDocument *document,QString searchString)
{
    QDomElement racine = m_docBooK.documentElement(); //renvoie la balise racine
    for(int pos=currentPosition+1;pos<rowsCount;pos++){
        QDomNode noeud = racine.childNodes().item(pos);
        QString  Nass=noTechkile(noeud.firstChildElement("nass").firstChild().toText().data()) ;
        if (Nass.contains(searchString)){
            moveToPosition(pos);
            searchInDoc(document,searchString);
            break;
        }
    }
}
