/****************************************************************************
**
** Copyright AbouZakaria.
** All rights reserved.
** Contact: AbouZakaria (yahia67@live.com)
**
** $xbook_BEGIN_LICENSE:GPL$
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3.0 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU General Public License version 3.0 requirements will be
** met: http://www.gnu.org/copyleft/gpl.html.
**
** If you have questions regarding the use of this file, please contact
** AbouZakaria (yahia67@live.com)
** $xbook_END_LICENSE$
**
****************************************************************************/
#ifndef XBOOK_H
#define XBOOK_H
#include <QObject>
#include <QTreeWidget>
#include <QDomDocument>
#include <QTextDocument>
#include <QTextEdit>
class xbook : public QObject
{
    Q_OBJECT

public:


    xbook();
    QTreeWidget *view;
    QTextEdit *textEdit;
    QString fileName;
    QString infoBookTitle;
    QString infoBookAutor;
    QString infoBookBetaka;

    int rowsCount;

    QString bookPage;
    QString bookPart;
    QString bookNass;
    int  currentPosition;
    int firstPosition;
    bool removeTechkile;
    QString fontName;

private:
    QString m_bookCurentId;
    QDomDocument m_docBooK;
    QString  m_tableBook;
    QString  m_tableTitle;
    QList<QString> m_listId;

public slots:
    bool load(const QString &f);
    void moveToPosition(int position);
    bool searchInDoc(QTextDocument *document,QString searchString);
    void findNext(QTextDocument *document,QString searchString);
    bool creatArchive();


private slots:
    void treeChargeFahrass(QString Bname);
    bool loadBookInfo(QString bookinfo);
    bool openBook(int position,QString bkpath);


    ////////*********text*********
    QString noTechkile(QString text) const;
    void convert_text(QString txt);

    ////////*********mdb*********
    void loadMdbBok(QString fn);
    bool creatBash(QString fn,bool bok);
    bool creatCsvFile();
    bool creatFiles(QString fn);
    bool creatXmlFile(QString f,QString table,QString csv);
    bool saveBookInfo();

    ////////////***********tar.gz*************************
    bool uzipBook(QString path);
    void removeTempDirs(QString dirName);
    bool removeTempFiles(QString tempDir);
    bool loadTarGz(QString path);

    /////////////////find**********************


};
#endif // XBOOK_H
